/*
 * Usuario.java
 *
 * Created on 30 de Julho de 2006, 00:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package info.everest.entity;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Entity class Usuario
 * 
 * @author Richter
 */
@Entity
@Table(name = "USUARIO")
@NamedQueries( {
  @NamedQuery(name = "Usuario.findByCodigo", query = "SELECT u FROM Usuario u WHERE u.codigo = :codigo"),
  @NamedQuery(name = "Usuario.findByUsuario", query = "SELECT u FROM Usuario u WHERE u.usuario = :usuario"),
  @NamedQuery(name = "Usuario.findBySenha", query = "SELECT u FROM Usuario u WHERE u.senha = :senha"),
  @NamedQuery(name = "Usuario.validaUsuario", query = "SELECT u FROM Usuario u WHERE u.usuario = :usuario and u.senha = :senha"),
  @NamedQuery(name = "Usuario.findByNome", query = "SELECT u FROM Usuario u WHERE u.nome like :nome"),
  @NamedQuery(name = "Usuario.findByEmail", query = "SELECT u FROM Usuario u WHERE u.email = :email"),
  @NamedQuery(name = "Usuario.findByTelefone", query = "SELECT u FROM Usuario u WHERE u.telefone = :telefone"),
  @NamedQuery(name = "Usuario.findByDatanascimento", query = "SELECT u FROM Usuario u WHERE u.datanascimento = :datanascimento")
})
public class Usuario implements Serializable {

  @Id
  @Column(name = "CODIGO", nullable = false)
  private BigInteger codigo;

  @Column(name = "USUARIO", nullable = false)
  private String usuario;

  @Column(name = "SENHA", nullable = false)
  private String senha;

  @Column(name = "NOME")
  private String nome;

  @Column(name = "EMAIL")
  private String email;

  @Column(name = "TELEFONE")
  private String telefone;

  @Column(name = "DATANASCIMENTO")
  @Temporal(TemporalType.DATE)
  private Date datanascimento;
  
  /** Creates a new instance of Usuario */
  public Usuario() {
  }

  /**
   * Creates a new instance of Usuario with the specified values
   * @param codigo the codigo of the Usuario
   */
  public Usuario(BigInteger codigo) {
    this.codigo = codigo;
  }

  /**
   * Creates a new instance of Usuario with the specified values
   * @param codigo the codigo of the Usuario
   * @param usuario the usuario of the Usuario
   * @param senha the senha of the Usuario
   */
  public Usuario(BigInteger codigo, String usuario, String senha) {
    this.codigo = codigo;
    this.usuario = usuario;
    this.senha = senha;
  }

  /**
   * Gets the codigo of this Usuario.
   * @return the codigo
   */
  public BigInteger getCodigo() {
    return this.codigo;
  }

  /**
   * Sets the codigo of this Usuario to the specified value.
   * @param codigo the new codigo
   */
  public void setCodigo(BigInteger codigo) {
    this.codigo = codigo;
  }

  /**
   * Gets the usuario of this Usuario.
   * @return the usuario
   */
  public String getUsuario() {
    return this.usuario;
  }

  /**
   * Sets the usuario of this Usuario to the specified value.
   * @param usuario the new usuario
   */
  public void setUsuario(String usuario) {
    this.usuario = usuario;
  }

  /**
   * Gets the senha of this Usuario.
   * @return the senha
   */
  public String getSenha() {
    return this.senha;
  }

  /**
   * Sets the senha of this Usuario to the specified value.
   * @param senha the new senha
   */
  public void setSenha(String senha) {
    this.senha = senha;
  }

  /**
   * Gets the nome of this Usuario.
   * @return the nome
   */
  public String getNome() {
    return this.nome;
  }

  /**
   * Sets the nome of this Usuario to the specified value.
   * @param nome the new nome
   */
  public void setNome(String nome) {
    this.nome = nome;
  }

  /**
   * Gets the email of this Usuario.
   * @return the email
   */
  public String getEmail() {
    return this.email;
  }

  /**
   * Sets the email of this Usuario to the specified value.
   * @param email the new email
   */
  public void setEmail(String email) {
    this.email = email;
  }

  /**
   * Gets the telefone of this Usuario.
   * @return the telefone
   */
  public String getTelefone() {
    return this.telefone;
  }

  /**
   * Sets the telefone of this Usuario to the specified value.
   * @param telefone the new telefone
   */
  public void setTelefone(String telefone) {
    this.telefone = telefone;
  }

  /**
   * Gets the datanascimento of this Usuario.
   * @return the datanascimento
   */
  public Date getDatanascimento() {
    return this.datanascimento;
  }

  /**
   * Sets the datanascimento of this Usuario to the specified value.
   * @param datanascimento the new datanascimento
   */
  public void setDatanascimento(Date datanascimento) {
    this.datanascimento = datanascimento;
  }

  /**
   * Returns a hash code value for the object.  This implementation computes 
   * a hash code value based on the id fields in this object.
   * @return a hash code value for this object
   */
  @Override
  public int hashCode() {
    int hash = 0;
    hash += (this.codigo != null ? this.codigo.hashCode() : 0);
    return hash;
  }

  /**
   * Determines whether another object is equal to this Usuario.  The result is 
   * <code>true</code> if and only if the argument is not null and is a Usuario object that 
   * has the same id field values as this object.
   * @param object the reference object with which to compare
   * @return <code>true</code> if this object is the same as the argument;
   * <code>false</code> otherwise
   */
  @Override
  public boolean equals(Object object) {
    if(object == this) return true;
    if(object == null) return false;

    if (object instanceof Usuario) {
      Usuario other = (Usuario)object;
      return (other.codigo!=null && other.codigo.equals(this.codigo));
    }
    
    return false;
  }

  /**
   * Returns a string representation of the object.  This implementation constructs 
   * that representation based on the id fields.
   * @return a string representation of the object
   */
  @Override
  public String toString() {
    return "info.everest.entity.Usuario[codigo=" + codigo + "]";
  }
  
}
